class MyAppUtils{

  static html_code_slider(c, appvar, id, irow = undefined){
    var fun, html,itag,oid,itag;
    itag            = irow === undefined ? '' : ',' + irow;
    oid             = 'o_' + c.param + (irow===undefined ? '' : '_' + irow);
    fun             = function(mod) {return '"MyAppUtils.html_set_slider_val(' + appvar + ',\'' + c.param + '\',\'' + id + '\',' + mod + ',\''+ oid + '\'' + itag + ')"';}; 
    html            = '<div class="slider"><input type="button" onclick=' + fun(-1) + ' value="-"><input id="' + id + '" type="range" min="' + c.min + '"   max="' + c.max + '"   value="' + c.value + '"   oninput=' + fun(0) + ' title="' + c.title + '"> ' + '<input type="button" onclick=' + fun(+1) + ' value="+">' + '<label>' + c.tag + ': </label> <output id="' + oid + '">' + c.value + '</output> </div>';
    return html;
  }

  static html_code_select(c, appvar, irow = undefined){
    var fun, html, j;
    fun             = '"MyAppUtils.html_set_select_val(' + appvar + ',\'' + c.param + '\',this,' + irow + ')"'; html += c.tag  + ': '; 
    html            = '';
    for ( j         = 0; j < c.list.length; j++){ 
      html          = html + '<input type="radio" name="'  + c.param + '"  value="' + c.list[j] + '"  onclick=' + fun + ((c.list[j] === c.value) ? 'checked="checked"' : '') + '>' + c.list[j] + ''; 
    };
    return html;
  }

  static html_code_items(ctrl,appvar,rnd, irow = undefined){
    var i,j,k,c,id,m,n,items,html,rows;
    
    items           = new Array(ctrl.length);
    for (k          = 0; k < ctrl.length; k++) { 
      c             = ctrl[k];
      id            = 'ctrl_' + k.toString() + '_' + rnd.toString();
      switch (c.type) {
        case 'slider' : items[k] = {type:'single',  code: MyAppUtils.html_code_slider(c, appvar, id,irow)  };  break;
        case 'select' : items[k] = {type:'single',  code: MyAppUtils.html_code_select(c, appvar, irow)     };  break;
        case 'table'  : 
          rows      = new Array(c.nrows);
          for ( i   = 0; i<c.nrows; i++){
            rows[i] = MyAppUtils.html_code_items(c.ictrl(i),appvar,rnd+i+1,i);  
          }
          items[k]  = {type:'table',   rows: rows, tag:c.tag, itags:c.itags   };  
          break;        
        default       : console.log('Unknown control type: ' + c.type);
      }
    }
    return items;
  }

  static html_insert_controls(divid,appvar,ctrl){
    // Inserts html controllers
    var div,html,rnd,items,i,j,k,item,ihtml;
    rnd             = Math.round(Math.random()*1e6);  
    html            = '';  
    html            = html + '<button onclick="' + appvar + '.toggle()">Start/stop</button>';
    html            = html + '<form>';
    items           = MyAppUtils.html_code_items(ctrl,appvar,rnd);
    for ( k         = 0; k < items.length; k++){ 
      item          = items[k];
      if (item.type === 'single') { html += item.code; }
      if (item.type === 'table')  { 
        html        = html + '<table><tr><th>' + item.tag + '</th><th>Controls</th></tr>';
        for ( i     = 0; i < item.rows.length; i++  ){        
          ihtml     = ''; for (j=0;j<item.rows[i].length; j++){ ihtml += item.rows[i][j].code; }
          html      = html + '<tr><td>' + item.itags[i] + '</td><td>' + ihtml + '</td></tr>';
        }      
        html        = html + '</table>';
      }
    }
    html            = html + '</form>';
    div             = document.getElementById(divid);
    div.innerHTML   = html;
  }

  static html_set_select_val(app, param, sel, irow){
    _run_           = app.setparam(param,sel.value, irow);
  }

  static html_set_slider_val(app, param, sliderid, mod, outid, irow){    
    var slider,newval;
    slider          = document.getElementById(sliderid);  
    newval          = Math.max(Math.min(Number(slider.max), Number(slider.value) + mod),Number(slider.min));
    slider.value    = newval.toString();  
    _run_           = app.setparam(param,newval, irow);  
    if (outid!==undefined){ document.getElementById(outid).innerHTML = newval;  }
  }


}

class MyApp_Sine      extends MyApplet{
  /******************************************************************************  
    Description:    Class for since curve applets
    Made by:        Kristian Stormark
    Version:        1.0.0
  *****************************************************************************/ 
  
  constructor(canvas){
    _run_           = super(canvas);                                                      // Run super-class constructor
    this.param      = {amp:50, speed:2, n:4, dampdx:25, resx:1, baseline:50, symb:'s'};   // Def parameters
  }

  init(){ 
    _run_           = this.bgbuff.clear([0,0,0]);                               // Clear bg buffer to black
    _run_           = this.stopwatch.tic('curve')                               // Start timer
  }
  
  putsymb(x,y,rgb=[255,0,0]){
    var buffer,symb;
    buffer          = this.buffer;
    symb            = this.param.symb;
    switch (symb){
      case '.'      :
        _run_       = buffer.putpixel(x,      y,      rgb);                     //  Put pixel        
        break;
      case 's'      :
        _run_       = buffer.putpixel(x-0.5,  y-0.5,  rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x+0.5,  y-0.5,  rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x-0.5,  y+0.5,  rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x+0.5,  y+0.5,  rgb);                     //  Put pixel
        break;
      case '+'      :
        _run_       = buffer.putpixel(x-1,    y,      rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x,      y,      rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x+1,    y,      rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x,      y-1,    rgb);                     //  Put pixel
        _run_       = buffer.putpixel(x,      y+1,    rgb);                     //  Put pixel        
        break;
      default       :
        _run_       = buffer.putpixel(x,      y,      rgb);                     //  Put pixel        
      
    }    
  }
  
  update(opt){    
    var buffer, x, y, y0, amp, t, cx, ct, ce, il, ir, w, h, dx, mx;             // Declare variables
    _run_           = this.bg2buff();                                           // Copy bg to buffer
    buffer          = this.buffer;                                              // Def short-ref, buffer
    h               = buffer.height;                                            // Def short-ref, buffer height
    w               = buffer.width;                                             // Def short-ref, buffer width
    t               = this.stopwatch.toc('curve')         / 1000;               // Get curve time in seconds
    y0              = this.param.baseline         * h     / 100;                // Get curve base-line
    amp             = this.param.amp        * 0.5 * h     / 100;                // Get curve amplitude
    dx              = this.param.dampdx     * 0.5 * w     / 100;                // Get curve size of edges (~damping)
    cx              = this.param.n  * 2 * Math.PI / w;                          // Get curve x mult (~#cycles)
    ct              = this.param.speed;                                         // Get curve t mult (~speed)    
    mx              = this.param.resx;                                          // Get curve x sampling factor (1,2,3..)
    for (var ix = 0; ix< mx*w; ix++){                                           // For each x sample loc
      x             = ix/mx;                                                    //  Calc current x value
      ce             = 1;                                                       //  Set default scale = 1
      il            = x < dx+1;     if (il){ ce = (x  - 1)/dx; }                //  Scale down at left edge
      ir            = x>(w-1-dx);   if (ir){ ce = (w-1 -x)/dx; }                //  Scale down at right edge
      y             = y0 + ce * amp * Math.sin( t * ct + x * cx );              //  Compute curve value
      _run_         = this.putsymb(x,y);
    }    
  }
  
  setparam(key,val){   
    var regs        = ['amp','speed','n', 'dampdx', 'resx', 'baseline','symb']; // Valid parameters
    if(regs.includes(key))  {this.param[key]    = val;           }              // If valid, update
  }
  
  param_ctrl (){
    // Returns parameter controller ranges (mainly intended for html)
    var ctrl,p;
    p               = this.param;
    ctrl            = new Array(7) ;
    ctrl[0]         = {type:'slider', min:0, max:100,      value:p.amp,       param:'amp',      tag:'Amplitude',  title:'Amplitude of wave'             };
    ctrl[1]         = {type:'slider', min:0, max:30,        value:p.speed,    param:'speed',    tag:'Speed',      title:'Speed of wave'                 };
    ctrl[2]         = {type:'slider', min:0, max:100,       value:p.n,        param:'n',        tag:'Cycles',     title:'Number of cycles'              };
    ctrl[3]         = {type:'slider', min:0, max:100,       value:p.dampdx,   param:'dampdx',   tag:'Edge',       title:'Width of edge zone (percent)'  };
    ctrl[4]         = {type:'slider', min:1, max:10,        value:p.resx,     param:'resx',     tag:'Sampling',   title:'Sampling factor (x)'           };
    ctrl[5]         = {type:'slider', min:0, max:100,       value:p.baseline, param:'baseline', tag:'Baseline',   title:'Base-line (y)'                 };
    ctrl[6]         = {type:'select', list: ['.','s','+'],  value:p.symb,     param:'symb',     tag:'Symbol',     title:'Point symbol'                  };
    return ctrl;
  }
  
}
